import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


    public class TorusSliceSelectorX {
	int X,Y,W;
	Complex Z;
	Complex FINAL;
	double U;
	Manager M;
	ListenSquare ZZ[]=new ListenSquare[10];
	ListenSquare AA[]=new ListenSquare[10];

	public TorusSliceSelectorX(int x,int y,int w) {
	    X=x;
	    Y=y;
	    W=w;
	    Z=new Complex(0,1.0/3.0);
	    FINAL=new Complex(0,1.0/3.0); 

            for(int i=0;i<5;++i) {
		ZZ[i]=new ListenSquare(X+15*i,Y-15,15,15,Color.white);
		AA[i]=new ListenSquare(X+2*W,Y+10*i,15,10,Color.white);
		AA[i].on=1;
		ZZ[i].on=1;
	    }
	    for(int i=5;i<10;++i) {
		int j=i-4;
		ZZ[i]=new ListenSquare(X+2*W-15*j,Y-15,15,15,Color.white);
		AA[i]=new ListenSquare(X+2*W,Y+W-10*j,15,10,Color.white);	
                AA[i].on=1;
		ZZ[i].on=1;
	    }
	    U=1.0;

	}


    public String cleanDouble(double t) {
	Double T=new Double(t);
        String v1=T.toString();
	if(Math.abs(t)<.000001) v1="0";
	try {
	    v1=v1.substring(0,7);
	}
	catch(Exception e) {} 
	return(v1);
    }


	public void render(Graphics2D g) {
	    AffineTransform AT1=AffineTransform.getScaleInstance(2*W,W);
	    AffineTransform AT2=AffineTransform.getTranslateInstance(X,Y);

            Color COL=new Color(0,100,100);
	    for(int j=0;j<10;++j) {
	       ZZ[j].render(g,COL);
	       AA[j].render(g,COL);
	    }



	    GeneralPath gp=new GeneralPath();
	    gp.moveTo(0,0);
	    gp.lineTo(0,1);
	    gp.lineTo(1,1);
	    gp.lineTo(1,0);
	    gp.closePath();

	    float y1=(float)(1.1);
	    float y2=(float)(1.3);
            gp.moveTo(0,y1);
	    gp.lineTo(0,y2);
	    gp.lineTo(1,y2);
	    gp.lineTo(1,y1);
            gp.closePath();


	    gp.closePath();
	    gp.transform(AT1);
	    gp.transform(AT2);
	    g.setColor(new Color(0,200,200));
	    g.fill(gp);
	    g.setColor(Color.white);
	    g.draw(gp);
	    gp.reset();




	    float x=(float)(0.5);

            gp.moveTo(0,1);
	    gp.lineTo(x,1);
	    gp.moveTo(0,0);
	    gp.lineTo(x,1);
	    gp.moveTo(x,0);
	    gp.lineTo(0,1);

            gp.moveTo(x,1);
	    gp.lineTo(1,1);
	    gp.moveTo(x,0);
	    gp.lineTo(1,1);
	    gp.moveTo(1,0);
	    gp.lineTo(x,1);

            gp.transform(AT1);
	    gp.transform(AT2);
            g.draw(gp);

            gp.reset();
	    gp.moveTo((float)(.5*Z.x),0);
	    gp.lineTo((float)(.5*Z.x),1);
	    gp.moveTo(0,(float)(1.0-Z.y));
	    gp.lineTo(1,(float)(1.0-Z.y));
	    g.setColor(new Color(0,0,0,100)); 
            gp.transform(AT1);
	    gp.transform(AT2);
	    g.draw(gp);

            gp.reset();
	    gp.moveTo((float)(.5*U+.5),y1);
	    gp.lineTo((float)(.5*U+.5),y2);
	    g.setColor(new Color(0,0,0,100)); 
            gp.transform(AT1);
	    gp.transform(AT2);
	    g.draw(gp);





	    g.drawString("z",X+W/2-20,Y+W-2);
	    g.drawString("A",X+2,Y+W/2-32);

	    g.setColor(Color.blue);
	    String S1=cleanDouble(FINAL.x);
	    g.drawString(S1,X+W/2-10,Y+W-2);
	    String S2=cleanDouble(FINAL.y);

	    String S4=cleanDouble(U);
            g.drawString(S4,X|10,(int)(Y+1.27*W));

	    for(int i=0;i<8;++i) {
		try{
		  String S3=S2.substring(i,i+1);
	          g.drawString(S3,X+2,-20+Y+W/2+10*i);
		} 
		catch(Exception e) {}
	    }
	}


         


	public void setFinal() {
	    if(Z.x<0) Z.x=0;
	    if(Z.x>2) Z.x=2;
	    if(Z.y<0) Z.y=0;
	    if(Z.y>1) Z.y=1;
	    FINAL=new Complex(Z);
	}


	public int process(Point P) {

	    int ret=0;
	    double x=P.x-X;
	    double y=P.y-Y;

	    if((x>=0)&&(y>=0)&&(x<=2*W)&&(y<=W)) {
	      x=1.00*x/W;
	      y=1.00-1.00*y/W;
	      Z.x=x;
	      Z.y=y;
	      ret=1;
	    }


	    if((x>=0)&&(y>=1.1*W)&&(x<=2*W)&&(y<=1.3*W)) {
	      U=1.00*x/W-1;
	    }





            for(int i=0;i<5;++i) {
		if(ZZ[i].inside(P)==1) Z.x=Z.x-Math.pow(10.0,-i-1);
		if(AA[i].inside(P)==1) Z.y=Z.y+Math.pow(10.0,-i-1);
	    }
	    for(int i=5;i<10;++i) {
		if(ZZ[i].inside(P)==1) Z.x=Z.x+Math.pow(10.0,4-i);
		if(AA[i].inside(P)==1) Z.y=Z.y-Math.pow(10.0,4-i);
	    }


	    setFinal();
	    return(ret);





	}




    }
