import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

public class ArithmeticGraphMarkings {
    public ArithmeticGraphMarkings() {
    }





    public static void drawMagicPoints(Graphics2D g,Manager M) {
	GeneralPath gp=new GeneralPath();
	GeneralPath gp2=new GeneralPath();
	PenroseProofData2 PD2=new PenroseProofData2();
	gp2.moveTo(0,0);
	for(int i=1;i<1024;++i) {
	    gp.moveTo((float)(PD2.sp[i][0]-.5),(float)(PD2.sp[i][1] +0));
	    gp.lineTo((float)(PD2.sp[i][0] -0),(float)(PD2.sp[i][1]+.5));
	    gp.lineTo((float)(PD2.sp[i][0]+.5),(float)(PD2.sp[i][1]+ 0));
	    gp.lineTo((float)(PD2.sp[i][0] -0),(float)(PD2.sp[i][1]-.5));
	  gp.closePath();
	  gp2.lineTo(PD2.sp[i][0],PD2.sp[i][1]);
	}

	  g.setColor(Color.yellow);
          gp=M.R.transform(gp);
	  g.draw(gp);
	  g.setColor(Color.blue);
          gp2=M.R.transform(gp2);
	  g.draw(gp2);
    }



    public static void drawAxesGraph(Graphics2D g,Manager M,Output OUT) {
	GeneralPath gp=new GeneralPath(); 
	Color  CC=M.C.CON_G.BASIC.M[0].C;
	int WW=1000;
	gp.moveTo(0,0);
        gp.lineTo(-WW,0);
	gp.lineTo(+WW,0);
	gp.lineTo(0,0);
        gp.lineTo(0,-WW);
	gp.lineTo(0,WW);
	if(M.C.EXPORT.mode==1) OUT.polyWrite(gp,CC,CC);
	gp=M.R.transform(gp);
        g.setColor(CC);
	g.draw(gp);  
    }



    public static void drawHalfplaneGraph(Graphics2D g,Manager M,Output OUT) {
	double A=Math.sqrt(5.0)-2.0;
	double d=M.C.CON_G.AGC.getOffset();
	d=.5*d;
	 Color COL=M.C.CON_G.BASIC.M[2].C;
          int WW=1000;
	  GeneralPath gp=new GeneralPath(); 
	  gp.moveTo((float)(-WW),(float)(-d+WW*A));
	  gp.lineTo((float)(+WW),(float)(-d-WW*A));
	  gp.lineTo((float)(+WW),(float)(-d-WW*A-WW));
	  gp.lineTo((float)(-WW),(float)(-d+WW*A-WW));
	  g.setColor(COL);	
          if(M.C.EXPORT.mode==1) OUT.polyWrite(gp,COL,COL);
	  gp=M.R.transform(gp);
	  g.fill(gp);
    }

    public static void drawHalflineGraph(Graphics2D g,Manager M,Output OUT) {
	double A=Math.sqrt(5.0)-2.0;
	double d=M.C.CON_G.AGC.getOffset();
	d=.5*d;
          Color COL=M.C.CON_G.BASIC.M[3].C;
          int WW=1000;
	  GeneralPath gp=new GeneralPath(); 
	  gp.moveTo((float)(-WW),(float)(-d+WW*A));
	  gp.lineTo((float)(+WW),(float)(-d-WW*A));
	  g.setColor(COL);
          if(M.C.EXPORT.mode==1) OUT.polyWrite(gp,COL,COL);
	  gp=M.R.transform(gp);
	  g.fill(gp);  
          g.draw(gp);
    }




    public static void drawGridGraph(Graphics2D g,Manager M,Output OUT) {
	GeneralPath gp=new GeneralPath(); 
           Color COL=M.C.CON_G.BASIC.M[1].C;
	for(int i=-100;i<=100;++i) {
	    gp.moveTo(-100,i);
	    gp.lineTo(+100,i);
            if(M.C.EXPORT.mode==1) OUT.polyWrite(gp,COL,COL);
   	    gp=M.R.transform(gp); 
	    g.setColor(COL);
	    g.draw(gp);
	    gp.reset();
	}

	for(int i=-100;i<=100;++i) {
	    gp.moveTo(i,100);
	    gp.lineTo(i,-100);
            if(M.C.EXPORT.mode==1) OUT.polyWrite(gp,COL,COL);
   	    gp=M.R.transform(gp); 
	    g.setColor(COL);
	    g.draw(gp);
	    gp.reset();
	}

    }



}
