import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;


public class PenroseSequenceHolder {
    Manager M;
    ListenSquare[] L=new ListenSquare[1000];
    ListenSquare INFO;
    int[][] list=new int[1000][20];
    PenroseShadowData shadow;
    int total;
    int length;
    Color[] C=new Color[10];
    SelectInteger[] I=new SelectInteger[2]; 
    int x,y;
    int current;
    PenroseTypeSquare[] G1=new PenroseTypeSquare[50];
    PenroseTypeSquare[] G2=new PenroseTypeSquare[50];
    Color[] COL=new Color[30];
    int focus=0;
    Rectangle R;
    AffineTransform A1,A2,A3;
    Documentation Doc;




    public PenroseSequenceHolder(Manager M,int x,int y,Color[] C,int[][] list) {
	this.M=M;
	this.x=x;
	this.y=y;
	this.C=C;
	this.list=list;
	for(int i=0;i<200;++i) {
	    int ii=i%20;
	    if((ii>= 0)&&(ii< 5))  L[i]=new ListenSquare(x+15*(ii- 0),y+10,12,12,Color.white);
	    if((ii>= 5)&&(ii<10))  L[i]=new ListenSquare(x+15*(ii- 5),y+25,12,12,Color.white);
	    if((ii>=10)&&(ii<15))  L[i]=new ListenSquare(x+15*(ii-10),y+40,12,12,Color.white);
	    if((ii>=15)&&(ii<20))  L[i]=new ListenSquare(x+15*(ii-15),y+55,12,12,Color.white);
	}

	Doc=new Documentation();
	I[1]=new SelectInteger(x,y+82,28,15,0,0,100,1);    //sequence scroll
	INFO=new ListenSquare(x+85,y-24,12,12,Color.white);

	current=-1;
	length=5;
	for(int i=0;i<=19;++i) G1[i]=new PenroseTypeSquare(0,0,0,0,Color.white,0);
	for(int i=0;i<=40;++i) G2[i]=new PenroseTypeSquare(0,0,0,0,Color.white,0);
	setColors();	 

    }



    public void setColors() {
	   COL[0]=Color.green;
           COL[1]=new Color(0,80,150);
	   COL[2]=new Color(0,110,200);
	   COL[3]=new Color(0,0,255);
	   COL[4]=new Color(50,80,255);
	   COL[5]=new Color(100,0,0);
	   COL[6]=new Color(130,0,0);
	   COL[7]=new Color(180,0,0);
	   COL[8]=new Color(220,00,0);
	   COL[9]=new Color(255,40,0);
	   COL[10]=new Color(255,80,0);
	   COL[11]=new Color(0,100,0);
	   COL[12]=new Color(0,150,0);
	   COL[13]=new Color(0,200,0);
	   COL[14]=new Color(0,255,0);
	   COL[15]=new Color(100,0,200);
	   COL[16]=new Color(150,0,250);
	   COL[17]=new Color(200,0,200);
	   COL[18]=new Color(250,0,250);
	   COL[19]=new Color(250,50,200);
           COL[20]=new Color(255,100,255);
	   COL[21]=new Color(0,150,150);
	   COL[22]=new Color(0,200,200);
	   COL[23]=new Color(0,255,255);
	   COL[24]=new Color(0,0,100);
	   COL[25]=new Color(0,0,100);
	   COL[26]=new Color(0,0,100);
	   COL[27]=new Color(0,0,100);
    }




    public void render(Graphics2D g,Color C1,Color C2,int choice,int LEN) {
	length=LEN;
	int a=0;
	int b=0;
	Color CCC;

	g.setColor(new Color(0,180,180));
	g.fillRect(x-3,y-24,100,255);

	g.setColor(Color.white);
	g.drawRect(x-3,y-24,100,255);
	INFO.infoRender(g);


	if(list!=null) {
          I[1].render(g,C[0],C[1],C[2]);
	}

	int lim1=I[1].val*20;
	int lim2=I[1].val*20+20;
	if(lim2>total) lim2=total;


	if(list!=null) {
	    for(int i=lim1;i<lim2;++i) {
		L[i].render2(g,new Color(60,120,255));
	    }
	}

	g.setColor(Color.white);  
        g.setFont(new Font("Helvetica",Font.PLAIN,10));

	if(list!=null) drawValues(g);
	if(list!=null) drawCurrent(g,C1);
	if((choice==1)&&(length==5)&&(shadow!=null)) drawShadow(g,C2);
    }




	public void drawValues(Graphics2D g) {
	    Integer I0=new Integer(total);
	    g.drawString(I0.toString()+":",x,y+79);

	    int x1=I[1].val*20;
	    int x2=x1+19;
	    Integer X1=new Integer(x1);
	    Integer X2=new Integer(x2);
	    g.drawString(X1.toString()+" thru "+X2.toString(),x,y+110);
	}







    public void drawCurrent(Graphics2D g,Color C1) {
	PenrosePartition PX=new PenrosePartition();
	if((length>0)&&(current>=0)) {
	    for(int i=0;i<length;++i) {
		int j=list[current][i];
		if(j<0) j=-j;
	       	G1[i]=new PenroseTypeSquare(x+15*i,y-8,12,12,COL[j],j);
		G1[i].typeRender(g,COL[j],j);
	    }
	}


    }



    public void drawShadow(Graphics2D g,Color C) {	
        PenrosePartition PX=new PenrosePartition();
	double PHI=(1+Math.sqrt(5))/2;
	double PHI3=PHI*PHI*PHI;	

	if((length>0)&&(current>=0)) {
	    for(int i=0;i<shadow.seq.length;++i) {
		int j=shadow.seq[i];
		if(j<0) j=-j;
	       	if((i>=  0)&&(i< 5)) G2[i]=new PenroseTypeSquare(x+15*(i- 0),y+120,12,12,COL[j],j);
	       	if((i>=  5)&&(i<10)) G2[i]=new PenroseTypeSquare(x+15*(i- 5),y+135,12,12,COL[j],j);
	       	if((i>= 10)&&(i<15)) G2[i]=new PenroseTypeSquare(x+15*(i-10),y+150,12,12,COL[j],j);
	       	if((i>= 15)&&(i<20)) G2[i]=new PenroseTypeSquare(x+15*(i-15),y+165,12,12,COL[j],j);
	       	if((i>= 20)&&(i<25)) G2[i]=new PenroseTypeSquare(x+15*(i-20),y+180,12,12,COL[j],j);
	       	if((i>= 25)&&(i<30)) G2[i]=new PenroseTypeSquare(x+15*(i-25),y+195,12,12,COL[j],j);


		G2[i].typeRender(g,COL[j],j);
	    }
	}
    }




    public void groupActivate(Color Y,int i1,int i2) {
	for(int i=0;i<total;++i) L[i].on=0;
        int sign=1;
	if(i2==2) sign=-1;
	for(int i=0;i<total;++i) {
	    int ii=list[i][focus];
	    if(ii==sign*i1) {
		L[i].on=1;
		L[i].C=Y;
	    }
	}
    }

    public void totalActivate(Color Y,int i1,int i2) {
	for(int i=0;i<total;++i) L[i].on=1;
        int focus=(length-1)/2;
        int sign=1;
	if(i2==2) sign=-1;
	for(int i=0;i<total;++i) {
	    int ii=list[i][focus];
	    if(ii*sign>0) {
		L[i].on=1;
		L[i].C=Y;
	    }
	}
    }


    public void printOut() {
	int cc=current+1;
	System.out.println("current "+cc);
	for(int i=0;i<length;++i) System.out.print(list[current+1][i]+" ");
	System.out.println("");
    }

    public void reset() {
         total=0;
         current=-1;
	 for(int i=0;i<999;++i) L[i].on=0;
    }



    public int process(Point X,Color Y,int i1) {
        int test=0;
	length=i1;
	I[1].modify(X);
	if(list!=null) {
           if(I[1].val*20>total) --I[1].val;
	   int lim1=I[1].val*20;
	   int lim2=I[1].val*20+20;
	   if(lim2>total) lim2=total;

	   for(int i=lim1;i<lim2;++i) {
	     if(L[i].inside(X)==1) {
		current=i;
		test=2;
		L[i].C=Y;
	        for(int q=0;q<=199;++q) L[q].on=0;
   	        L[i].on=1;
	     }
	   }
	}
	if(INFO.inside(X)==1) test=20;
	return(test);
    }







}

